Page MenuHomeFreeBSD

libthr rtld locks: do not leak URWLOCK_READ_WAITERS into child
ClosedPublic

Authored by kib on May 20 2023, 8:28 AM.
Tags
None
Referenced Files
Unknown Object (File)
Sun, Feb 18, 8:28 AM
Unknown Object (File)
Jan 18 2024, 1:19 PM
Unknown Object (File)
Jan 12 2024, 8:06 AM
Unknown Object (File)
Jan 5 2024, 10:28 PM
Unknown Object (File)
Jan 4 2024, 2:08 PM
Unknown Object (File)
Dec 22 2023, 11:43 PM
Unknown Object (File)
Dec 7 2023, 6:46 AM
Unknown Object (File)
Dec 7 2023, 6:13 AM
Subscribers

Details

Summary
Since there is only the current thread in the child, no pending readers
exist.  Clear the bit, since it confuses future attempts to acquire
write ownership of the rtld locks, due to URWLOCK_PREFER_READERS flag.

PR:     271490

Diff Detail

Repository
rG FreeBSD src repository
Lint
Lint Not Applicable
Unit
Tests Not Applicable

Event Timeline

kib requested review of this revision.May 20 2023, 8:28 AM
kib added a reviewer: markj.

To be future-proof, clear all state about pending writers and readers.

It would be nice to turn the test case from PR 271490 into a regression test case, either in the base system or in stress2.

lib/libthr/thread/thr_rtld.c
161

Perhaps use __predict_false here.

This revision is now accepted and ready to land.May 22 2023, 1:32 PM